
local MakePlayerCharacter = require "prefabs/player_common"


local assets = {

        Asset( "ANIM", "anim/player_basic.zip" ),
        Asset( "ANIM", "anim/player_idles_shiver.zip" ),
        Asset( "ANIM", "anim/player_actions.zip" ),
        Asset( "ANIM", "anim/player_actions_axe.zip" ),
        Asset( "ANIM", "anim/player_actions_pickaxe.zip" ),
        Asset( "ANIM", "anim/player_actions_shovel.zip" ),
        Asset( "ANIM", "anim/player_actions_blowdart.zip" ),
        Asset( "ANIM", "anim/player_actions_eat.zip" ),
        Asset( "ANIM", "anim/player_actions_item.zip" ),
        Asset( "ANIM", "anim/player_actions_uniqueitem.zip" ),
        Asset( "ANIM", "anim/player_actions_bugnet.zip" ),
        Asset( "ANIM", "anim/player_actions_fishing.zip" ),
        Asset( "ANIM", "anim/player_actions_boomerang.zip" ),
        Asset( "ANIM", "anim/player_bush_hat.zip" ),
        Asset( "ANIM", "anim/player_attacks.zip" ),
        Asset( "ANIM", "anim/player_idles.zip" ),
        Asset( "ANIM", "anim/player_rebirth.zip" ),
        Asset( "ANIM", "anim/player_jump.zip" ),
        Asset( "ANIM", "anim/player_amulet_resurrect.zip" ),
        Asset( "ANIM", "anim/player_teleport.zip" ),
        Asset( "ANIM", "anim/wilson_fx.zip" ),
        Asset( "ANIM", "anim/player_one_man_band.zip" ),
        Asset( "ANIM", "anim/shadow_hands.zip" ),
        Asset( "SOUND", "sound/sfx.fsb" ),
        Asset( "SOUND", "sound/wilson.fsb" ),
        Asset( "ANIM", "anim/beard.zip" ),

        Asset( "ANIM", "anim/alyx.zip" ),
		
		Asset("ATLAS", "images/inventoryimages/dog.xml"),
        Asset("IMAGE", "images/inventoryimages/dog.tex"),
}
local prefabs = {
"dog",
"scraps",
"gears",
}
local start_inv = {

"alyxpistol",
"pammo","pammo","pammo","pammo","pammo","pammo","pammo","pammo","pammo","pammo",
"pammo","pammo","pammo","pammo","pammo","pammo","pammo","pammo","pammo","pammo",
"pammo","pammo","pammo","pammo","pammo","pammo","pammo","pammo","pammo","pammo",
"dog",
	
}

local fn = function(inst)

    -- if not inst:HasTag("dogmaster") then
	-- local x, y, z = inst.Transform:GetWorldPosition()
	-- SpawnPrefab("dog").Transform:SetPosition(x-4, y, z-4)
	-- inst:AddTag("dogmaster")
	-- end
	
	-- choose which sounds this character will play
	inst.soundsname = "willow"

	-- Minimap icon
	inst.MiniMapEntity:SetIcon( "alyx.tex" )
	
	if IsDLCEnabled and IsDLCEnabled(REIGN_OF_GIANTS) then
	inst:SetStateGraph("SGalyx_rog")
	print ("ROG Enable: LOADED ROG STATE")
	else
	inst:SetStateGraph("SGalyx")
	print ("ROG Disable: LOADED VANILLA STATE")
	end
	inst:AddTag("alyx")
	inst.components.health:SetMaxHealth(100)
	inst.components.hunger:SetMax(130)
	inst.components.sanity:SetMax(200)
	
    inst.components.hunger:SetRate(TUNING.WILSON_HUNGER_RATE)
	inst.components.combat.damagemultiplier = 1
	inst.components.combat.min_attack_period = 0.4
	inst.components.locomotor.walkspeed = (TUNING.WILSON_WALK_SPEED * 1.17)
	inst.components.locomotor.runspeed = (TUNING.WILSON_RUN_SPEED * 1.17)
    inst.components.sanity.neg_aura_mult = 0.65
	inst.components.sanity.night_drain_mult = 0.65
	
	
	local doghead = Ingredient( "doghead", 1 ) 
    doghead.atlas = "images/inventoryimages/doghead.xml"
    local dogbody = Ingredient( "dogbody", 1 ) 
    dogbody.atlas = "images/inventoryimages/dogbody.xml"
    local dogparts = Ingredient( "dogparts", 1 ) 
    dogparts.atlas = "images/inventoryimages/dogparts.xml"
	
	local dog = Recipe("dog", { doghead, dogbody, dogparts, Ingredient("gears", 4) }, RECIPETABS.SCIENCE, {SCIENCE=0})
    dog.atlas = "images/inventoryimages/dog.xml"
	
	
end

return MakePlayerCharacter("alyx", prefabs, assets, fn, start_inv)
