local assets=
{ 
    Asset("ANIM", "anim/alyxpistol.zip"),
    Asset("ANIM", "anim/swap_alyxpistol.zip"), 
    Asset("ATLAS", "images/inventoryimages/alyxpistol.xml"),
    Asset("IMAGE", "images/inventoryimages/alyxpistol.tex"),	
	Asset("ANIM", "anim/ui_alyxgun_2x1.zip"), 	
	
}

local prefabs = 
{
"alyxbullet",
"alyxammo",
"effects",
 
}
local function onequip(inst, owner)
    owner.AnimState:OverrideSymbol("swap_object", "swap_alyxpistol", "wand")
    owner.AnimState:Show("ARM_carry") 
    owner.AnimState:Hide("ARM_normal")
	inst.components.container:Open(owner)
	
end

local function onunequip(inst, owner) 
    owner.AnimState:Hide("ARM_carry") 
    owner.AnimState:Show("ARM_normal") 
	inst.components.container:Close(owner)
end

local slotpos = {}

--for y = 0, 1 do
	table.insert(slotpos, Vector3(-80, -110 ,0))
	table.insert(slotpos, Vector3(0, -110 ,0))
	--table.insert(slotpos, Vector3(-162 +75, -y*75 + 114 ,0))
--end

local function itemtest(inst, item, slot)
	return item.prefab == "pammo"
end
local function canattack(inst, target)
    if GetPlayer().components.inventory:Has("pammo", 1) 
	and TheInput:IsKeyDown(KEY_R) then
    inst.components.container:GiveItem("pammo",1)
    end
    if inst.components.container:Has("pammo", 1) then
       return true
    end
end
local function onattack_alyxpistol(inst, owner, target)

  inst.components.container:Open(owner)
  
  if target:HasTag("mansize") then
  inst.components.weapon:SetDamage(45)  
  elseif target:HasTag("tree") or target:HasTag("rocky") then
  inst.components.weapon:SetDamage(25)
  elseif target:HasTag("dog") then
  inst.components.weapon:SetDamage(0)  
  else 
  inst.components.weapon:SetDamage(35)  
  end  

	if not (target:HasTag("wall") or target:HasTag("chess") or target:HasTag("rocky") 
	or target:HasTag("insect") or target:HasTag("structure") or target:HasTag("hive")) then
	SpawnPrefab("blood").Transform:SetPosition(target.Transform:GetWorldPosition())
	end	

	inst.components.container:ConsumeByName("pammo", 1)
	
end

local function fn(Sim)

	local inst = CreateEntity()
	local trans = inst.entity:AddTransform()
	local anim = inst.entity:AddAnimState()
	inst.entity:AddSoundEmitter() 
    ---- 
    MakeInventoryPhysics(inst)
    
    anim:SetBank("wand")
    anim:SetBuild("alyxpistol")
    anim:PlayAnimation("idle")
    
    inst:AddTag("sharp")
    inst:AddTag("pistol")

    inst:AddComponent("weapon")
    inst.components.weapon:SetDamage(35)
    inst.components.weapon:SetRange(7.5)
    inst.components.weapon:SetOnAttack(onattack_alyxpistol)
    inst.components.weapon:SetCanAttack(canattack)
    inst.components.weapon:SetProjectile("ninemm")
	
    -- inst:AddComponent("finiteuses")
    -- inst.components.finiteuses:SetMaxUses(100)
    -- inst.components.finiteuses:SetUses(100)    
    -- inst.components.finiteuses:SetOnFinished( onfinished )
	
	inst:AddComponent("container")
	inst.components.container.itemtestfn = itemtest
    inst.components.container:SetNumSlots(#slotpos)
    inst.components.container.widgetslotpos = slotpos
    inst.components.container.widgetanimbank = "ui_backpack_2x4"
    inst.components.container.widgetanimbuild = "ui_alyxgun_2x1"
    inst.components.container.widgetpos = Vector3(-325,-325,0)
	inst.components.container.widgetpos_controller = Vector3(-325,-325,0)
    inst.components.container.side_widget = true
    inst.components.container.type = "magazine"

	inst:AddComponent("inspectable")
    
    inst:AddComponent("inventoryitem")
	inst.components.inventoryitem.atlasname = "images/inventoryimages/alyxpistol.xml"
 
    inst:AddComponent("equippable")
	


    inst.components.equippable:SetOnEquip( onequip )
    inst.components.equippable:SetOnUnequip( onunequip )
	
		
    inst:DoPeriodicTask(0.1, function()
    if inst.components.equippable.isequipped then
     if not inst.components.container:Has("pammo", 1) then
     inst:AddTag("empty")
         
	 elseif inst.components.container:Has("pammo", 1) then
	 inst:RemoveTag("empty")
     end 
    end
 end)
 
 local minimap = inst.entity:AddMiniMapEntity()
	minimap:SetIcon( "alyxgun.tex" )
 
    return inst
end

STRINGS.NAMES.ALYXPISTOL = "Alyx's gun"
STRINGS.RECIPE_DESC.ALYXPISTOL = "Go to Pistol variation"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.ALYXPISTOL = "Pistol variation."

return  Prefab("common/inventory/alyxpistol", fn, assets, prefabs)