require "stategraphs/SGdog"

local assets =
{
	Asset("ANIM", "anim/dog.zip"),	
	Asset("SOUNDPACKAGE", "sound/half2.fev"),
    Asset("SOUND", "sound/half2.fsb"),
	Asset( "IMAGE", "images/inventoryimages/dog.tex"),
	Asset( "ATLAS", "images/inventoryimages/dog.xml" ),
}

local prefabs = 
{
"scraps",
}

SetSharedLootTable( 'dog',
{
        	
})
 
require "brains/dogbrain"

local function Retarget(inst)

    local newtarget = FindEntity(inst, 20, function(guy)
            return  guy.components.combat and 
                    inst.components.combat:CanTarget(guy) and
                    (guy.components.combat.target == GetPlayer() or GetPlayer().components.combat.target == guy)
    end)

    return newtarget
end

local function OnAttacked(inst, data)
    --print(inst, "OnAttacked")
    local attacker = data.attacker

    if attacker and attacker:HasTag("alyx") then
        inst.components.health:SetVal(0)
    else
        inst.components.combat:SetTarget(attacker)
    end
end

local function fn(Sim)
	local inst = CreateEntity()
	local trans = inst.entity:AddTransform()
	local anim = inst.entity:AddAnimState()
	local sound = inst.entity:AddSoundEmitter()
    local light = inst.entity:AddLight()
	local shadow = inst.entity:AddDynamicShadow()	
	inst.Transform:SetFourFaced()
	--local s = 1.3 local a = 9 local c = 15
	local s = 1.2 local a = 9 local c = 15	
	local b = a/3
	local d = c/18.75
	inst.Transform:SetScale(s,s,s)
	shadow:SetSize(a,b)    
    MakeCharacterPhysics(inst, c, d)
	
    light:SetIntensity(.6)
    light:SetRadius(.5)
    light:SetFalloff(.6)
    light:Enable(true)
    light:SetColour(255/255, 50/255, 50/255)
    
    local brain = require "brains/dogbrain"
    inst:SetBrain(brain)
    
    anim:SetBank("dog")
    anim:SetBuild("dog")
    --anim:SetBloomEffectHandle( "shaders/anim.ksh" )
    --anim:PlayAnimation("idle", true)
    --inst.AnimState:SetMultColour(1,1,1,.6)
    
    inst:AddTag("character")
    inst:AddTag("scarytoprey")
    inst:AddTag("noauradamage")
    inst:AddTag("notraptrigger")
    inst:AddTag("dog")

    inst:AddComponent("locomotor") 
    --inst.components.locomotor.walkspeed = 7
	local spd=5.5	
    inst.components.locomotor.runspeed = spd    
    inst:SetStateGraph("SGdog")    
    inst:AddComponent("inspectable")    
    inst:AddComponent("health")
	local hlth=2400	
    inst.components.health:SetMaxHealth(hlth)
    inst.components.health:StartRegen(10, 30)

	inst:AddComponent("combat")
	local dogdam=50
    inst.components.combat.defaultdamage = dogdam
	inst.components.combat:SetAreaDamage(2.5,0.75)
    inst.components.combat.playerdamagepercent = 0
	inst.components.combat:SetAttackPeriod(1.3)
    inst.components.combat:SetRetargetFunction(3, Retarget)

    ------------------      
    --inst.SoundEmitter:PlaySound("dontstarve/ghost/ghost_girl_howl_LP", "howl")
    
    inst:AddComponent("follower")
	local player = GetPlayer()
	if player and player.components.leader then
		player.components.leader:AddFollower(inst)
	end    

local function OnAttack(inst)
      if math.random() < 0.33 then	  
	  inst.components.combat.defaultdamage = 70
	  else inst.components.combat.defaultdamage = 35
	  end
end

    inst:ListenForEvent("attacked", OnAttacked)
	inst:ListenForEvent("doattack", OnAttack)
	
	inst:AddComponent("lootdropper")
    inst.components.lootdropper:SetChanceLootTable('dog')

    local minimap = inst.entity:AddMiniMapEntity()
	minimap:SetIcon( "dog.tex" )    
    
    return inst
end

STRINGS.NAMES.DOG = "Dog"
STRINGS.RECIPE_DESC.DOG = "Revive Dog."
STRINGS.CHARACTERS.GENERIC.DESCRIBE.DOG = "Guardian of Alyx."

return Prefab( "common/monsters/dog", fn, assets, prefabs ) 
