local assets=
{ 
    Asset("ANIM", "anim/doghead.zip"),    
    Asset("ATLAS", "images/inventoryimages/doghead.xml"),
    Asset("IMAGE", "images/inventoryimages/doghead.tex"),
	
	Asset("ANIM", "anim/dogbody.zip"),    
    Asset("ATLAS", "images/inventoryimages/dogbody.xml"),
    Asset("IMAGE", "images/inventoryimages/dogbody.tex"),
	
	Asset("ANIM", "anim/dogparts.zip"),    
    Asset("ATLAS", "images/inventoryimages/dogparts.xml"),
    Asset("IMAGE", "images/inventoryimages/dogparts.tex"),
	
	
}

local prefabs = 
{
}

local function fnhead()

    local inst = CreateEntity()
    local trans = inst.entity:AddTransform()
    local anim = inst.entity:AddAnimState()
    MakeInventoryPhysics(inst)
    
    anim:SetBank("doghead")
    anim:SetBuild("doghead")
    anim:PlayAnimation("idle")	  
    inst:AddComponent("inspectable")
      
    inst:AddComponent("inventoryitem")
    inst.components.inventoryitem.imagename = "doghead"
    inst.components.inventoryitem.atlasname = "images/inventoryimages/doghead.xml"
	
	local minimap = inst.entity:AddMiniMapEntity()
	minimap:SetIcon( "doghead.tex" )
    
    return inst
end

local function fnbody()

    local inst = CreateEntity()
    local trans = inst.entity:AddTransform()
    local anim = inst.entity:AddAnimState()
    MakeInventoryPhysics(inst)
    
    anim:SetBank("dogbody")
    anim:SetBuild("dogbody")
    anim:PlayAnimation("idle")	  
    inst:AddComponent("inspectable")
      
    inst:AddComponent("inventoryitem")
    inst.components.inventoryitem.imagename = "dogbody"
    inst.components.inventoryitem.atlasname = "images/inventoryimages/dogbody.xml"
	
	local minimap = inst.entity:AddMiniMapEntity()
	minimap:SetIcon( "dogbody.tex" )
    
    return inst
end

local function fnparts()

    local inst = CreateEntity()
    local trans = inst.entity:AddTransform()
    local anim = inst.entity:AddAnimState()
    MakeInventoryPhysics(inst)
    
    anim:SetBank("dogparts")
    anim:SetBuild("dogparts")
    anim:PlayAnimation("idle")	  
    inst:AddComponent("inspectable")
      
    inst:AddComponent("inventoryitem")
    inst.components.inventoryitem.imagename = "dogparts"
    inst.components.inventoryitem.atlasname = "images/inventoryimages/dogparts.xml"
	
	local minimap = inst.entity:AddMiniMapEntity()
	minimap:SetIcon( "dogparts.tex" )
    
    return inst
end

STRINGS.NAMES.DOGHEAD = "Dog's head"
--STRINGS.RECIPE_DESC.DOGHEAD = "Go to Pistol variation"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.DOGHEAD = "Need to assemble it."

STRINGS.NAMES.DOGBODY = "Dog's body"
--STRINGS.RECIPE_DESC.DOGBODY = "Go to Pistol variation"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.DOGBODY = "Need to assemble it."

STRINGS.NAMES.DOGPARTS = "Dog's the other parts"
--STRINGS.RECIPE_DESC.DOGPARTS = "Go to Pistol variation"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.DOGPARTS = "Need to assemble it."



return  Prefab("common/inventory/doghead", fnhead, assets, prefabs),
        Prefab("common/inventory/dogbody", fnbody, assets, prefabs),
        Prefab("common/inventory/dogparts", fnparts, assets, prefabs) 		