require("stategraphs/commonstates")
local event_handlers=
{
    EventHandler("doattack", function(inst) if inst.components.health:GetPercent() > 0 then inst.sg:GoToState("attack") end end),
	EventHandler("attacked", function(inst, data) 
	if not inst.components.health:IsDead() and not inst.sg:HasStateTag("attack") then 
	if not inst.sg:HasStateTag("hit") and not data.attacker:HasTag("insect") then
	inst.sg:GoToState("hit") end end end),
    EventHandler("death", function(inst) inst.sg:GoToState("death") end),
    EventHandler("locomote", 
        function(inst)         	
            if inst.components.locomotor:WantsToMoveForward() then                
                if not (inst.sg:HasStateTag("moving") or inst.sg:HasStateTag("busy")) then 
				    	
                    inst.sg:GoToState("run")
                end           
            else            	
                if not (inst.sg:HasStateTag("idle") or inst.sg:HasStateTag("busy")) then                                 	
                    inst.sg:GoToState("idle")
                end
            end
        end),
}

local states=
{
    State{
        name = "idle",        
        tags = {"idle", "canrotate"},
        
        onenter = function(inst, playanim)
        inst.AnimState:PlayAnimation("idle", true)
        end,
    },	
    State{

        name = "run",        
        tags = {"run", "canrotate", "moving" },
        onenter = function(inst, playanim)        	
            inst.AnimState:PlayAnimation("run", true)    		
    		inst.components.locomotor:RunForward()            
        end,
		timeline=
        {
		    TimeEvent(0*FRAMES, function(inst)
			--local dogstepvol = GetModConfigData("dogstepvol","Alyx Vance and Dog")
            if dogstepvol == "10" then			
			inst.SoundEmitter:PlaySound("half2/dog/step")		    
			elseif dogstepvol == "5" then           		
			inst.SoundEmitter:PlaySound("half2/dog/step_half")
			elseif dogstepvol == "2.5" then	            			
			inst.SoundEmitter:PlaySound("half2/dog/step_few")
            end			
			end),
        },
		events=
        {   
            EventHandler("animover", function(inst) inst.sg:GoToState("run") end ),        
        },
    },   
	State{
        name = "attack",
        tags = {"attack", "busy"},

        onenter = function(inst, target)
            inst.sg.statemem.target = target
            inst.Physics:Stop()
            inst.components.combat:StartAttack()
            --inst.AnimState:PlayAnimation("atk_pre")
            inst.AnimState:PlayAnimation("atk")
        end,

        timeline=
        {

			TimeEvent(5*FRAMES, function(inst) inst.SoundEmitter:PlaySound("half2/dog/punch") end),
            TimeEvent(6*FRAMES, function(inst) inst.components.combat:DoAttack(inst.sg.statemem.target) end),
        },

        events=
        {
            EventHandler("animqueueover", function(inst) inst.sg:GoToState("idle") end),
        },
    },
	State{
		name = "hit",
        tags = {"busy", "hit"},

        onenter = function(inst, cb)
            inst.Physics:Stop()
            inst.AnimState:PlayAnimation("hit")
        end,

        events=
        {
			EventHandler("animover", function(inst) inst.sg:GoToState("idle") end),
        },
    },
	State{
        name = "death",
        tags = {"busy"},

        onenter = function(inst)
			inst.SoundEmitter:PlaySound("half2/dog/death")
            inst.AnimState:PlayAnimation("death")
            inst.Physics:Stop()
            RemovePhysicsColliders(inst)            
            inst.components.lootdropper:DropLoot(Vector3(inst.Transform:GetWorldPosition()))            
        end,

    },
		
		
}	
CommonStates.AddFrozenStates(states)

	   



return StateGraph("dog", states, event_handlers, "idle", {})